unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Koniec: TButton;
    Odpowiedz: TMemo;
    Liczby: TMemo;
    Licz: TButton;
    Opis: TRichEdit;
    procedure KoniecClick(Sender: TObject);
    procedure LiczClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
 n=5;
 k=9;
type
 TTab = array [1..n] of integer;
var
 T : TTab;

procedure Losuj (var A: TTab; d, g: integer);
 var
  i: integer;
begin
 for i:=1 to n do
  A[i] := d + random(g-d+1);
end; {Losuj}

procedure Wypisuj (A: TTab; var liczby: TMemo);
 var
  i: integer;
begin
 for i:=1 to n do
  liczby.Lines.Add(intToStr(i)+': '+IntTostr(A[i]));
end; {Wypisuj}

function SumaPrzed(j: integer; A: TTab): integer;
 var
  i, s: integer;
begin
 s:=0;
 for i:=1 to j-1 do
   s:= s+A[i];
 SumaPrzed:=s
end; {SumaPrzed}

function SumaZa(j: integer; A: TTab): integer;
 var
  i, s: integer;
begin
 s:=0;
 for i:=j+1 to n do
   s:= s+A[i];
 SumaZa:=s
end; {SumaZa}

function Sprawdz(A: TTab): boolean;
var
 i: integer;
begin
 Sprawdz := false;
 for i:=1 to n do
  if A[i]= sumaPrzed(i, A) - sumaZa(i,A)
  then
    Sprawdz := true;
end; {Sprawd}

// I wersja nieco efektywniejsza, przerywajca obliczenia, gdy znamy ju wynik
function Sprawdz2(A: TTab): boolean;
var
 i  : integer;
 ok : boolean;
begin
 ok := false;
 i  := 1;

 while (i <= n) and not ok do
  if A[i]= sumaPrzed(i, A) - sumaZa(i,A)
  then
    ok := true
  else
    i := i + 1;

 Sprawdz2 := ok;
end; {Sprawd2}

procedure TForm1.KoniecClick(Sender: TObject);
begin
 close
end;

procedure TForm1.LiczClick(Sender: TObject);
begin
 Liczby.Clear;
 Odpowiedz.Clear;
 Losuj(T, -k, k);
 Wypisuj(T, Liczby);
 if Sprawdz2(T)
 then
  Odpowiedz.Text := 'Tak'
 else
  Odpowiedz.Text := 'Nie';
end;

end.
